<?php

function IsRobot(){
  $agent007 = trim ( StrToUpper( $_SERVER['HTTP_USER_AGENT'] ) );
  if( strlen( $agent007 ) <= 1 ){ # "-", "", 99% this is bot
    return true;
  }

  # see all list of bots here: http://www.botsvsbrowsers.com/category/1/index.html
  $filter = array( "BOT", "SPIDER", "CRAWLER", "SCOUT", "SLEUTH", "JAKARTA"); #roBOT	#include your own key words
  
  $countValues = Count( $filter );
    for( $i = 0; $i < $countValues; $i++ ){
    if( strpos( $agent007, $filter[$i] ) != false ){
      return true;
    }
  }
  return false;
}

function ToCount( $filename, $zeroPadding ){
	$file = fopen( $filename, "r+" );
	if( $file ){
		if( flock( $file, LOCK_EX ) ){
			$counter = fread( $file, $zeroPadding );
      if( IsRobot() == false ){ # !!!
        $counter++;
        ftruncate( $file, 0 );
        rewind( $file );
        fwrite( $file, $counter );
      }
			flock( $file, LOCK_UN );
			fclose( $file );
			if( $zeroPadding ){
        $counter = sprintf( "%0".$zeroPadding."s", $counter);
      }
      return $counter;
    }
	}
  return 0;
}

function ToCountPerDay( $filename ){

  if( IsRobot() == true )
    return;

  $data = file( $filename, FILE_SKIP_EMPTY_LINES | FILE_IGNORE_NEW_LINES );
     
  $date_today = date("d.m.y");
  $flag = 0;
  if( $data ){
    for( $i=0; $i < count($data); $i++){
      list( $date, $count ) = explode( "|", $data[$i] );
        if(  $date_today == $date ){
          $count = 1 + (int) $count;
          $data[$i] = $date."|".$count;
          $flag = 1;
          break;
       }
    }
  }

  if( $flag == 0 ){ #insert new day
    array_unshift( $data, $date_today."|1" );
  }

  $file = fopen( $filename, "r+" );
	if( $file ){
    if( flock( $file, LOCK_EX ) ){
      ftruncate( $file, 0 );
      for( $i=0; $i < count($data); $i++){
        fwrite( $file, $data[$i]."\n" );
      }
		  flock( $file, LOCK_UN );
		  fclose( $file );
    }
	}
  
  # output only for test  
  if( $data ){
    for( $i=0; $i < count($data); $i++){
      echo $data[$i]."<BR>"; 
    }
  }  
}

function ShowCounterAsImage( $counter, $pathToImages, $extensionImage){
    $len = StrLen( $counter );
    $pathLocal = "0.".$extensionImage;
    $size = GetImageSize( $pathLocal );		#all images are equal
    for( $i = 0; $i < $len; $i++ ){
      $num = SubStr( $counter, $i, 1);
      echo "<IMG SRC = '".$pathToImages.$num.".".$extensionImage."' WIDTH='".$size[0]."' HEIGHT='".$size[1]."' BORDER = '0' ALT = '".$num."'>";
    }
}

?>